/*--------------------------------------------------------
   EXAMPLE5.C -- Multiple Document Interface Demonstration
  --------------------------------------------------------*/

#include <windows.h>
#include <stdlib.h>
#include "example5.h"
#include "pv.h"

long FAR PASCAL FrameWndProc  (HWND, WORD, WORD, LONG) ;
BOOL FAR PASCAL CloseEnumProc (HWND, LONG) ;
long FAR PASCAL DataEntryWndProc  (HWND, WORD, WORD, LONG) ;
long FAR PASCAL RectWndProc   (HWND, WORD, WORD, LONG) ;
long FAR PASCAL ControlsWndProc   (HWND, WORD, WORD, LONG) ;
VIEWPROC lpfnDataEntryWndProc;
VIEWPROC lpfnRectWndProc;
VIEWPROC lpfnControlsWndProc;
VIEW     MDI1;
HWND     hWndMDI1;
VIEW     MDI2;
HWND     hWndMDI2;
VIEW     MDI3;
HWND     hWndMDI3;
int      RetCode;


// global variables

char   szFrameClass [] = "MdiFrame" ;
HANDLE hInst, gblInstance;
HMENU  hMenuInit, hMenuDataEntry, hMenuRect, hMenuControls;
HMENU  hMenuInitWindow, hMenuDataEntryWindow, hMenuRectWindow, hMenuControlsWindow;

int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance,
                    LPSTR lpszCmdLine, int nCmdShow)
   {
   HANDLE   hAccel ;
   HWND     hwndFrame, hwndClient ;
   MSG      msg ;
   WNDCLASS wndclass ;

   gblInstance = hInst = hInstance ;

   lpfnDataEntryWndProc = (VIEWPROC) MakeProcInstance((FARPROC)DataEntryWndProc, gblInstance);
   lpfnRectWndProc = (VIEWPROC) MakeProcInstance((FARPROC)RectWndProc, gblInstance);
   lpfnControlsWndProc = (VIEWPROC) MakeProcInstance((FARPROC)ControlsWndProc, gblInstance);

   if (!hPrevInstance)
      {
                // Register the frame window class

      wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
      wndclass.lpfnWndProc   = FrameWndProc ;
      wndclass.cbClsExtra    = 0 ;
      wndclass.cbWndExtra    = 0 ;
      wndclass.hInstance     = hInstance ;
      wndclass.hIcon         = LoadIcon (hInstance, "example5") ;
      wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
      wndclass.hbrBackground = COLOR_APPWORKSPACE + 1 ;
      wndclass.lpszMenuName  = NULL ;
      wndclass.lpszClassName = szFrameClass ;

      RegisterClass (&wndclass) ;

      }


           // Obtain handles to three possible menus & submenus
   hMenuInit  = LoadMenu (hInst, "MdiMenuInit") ;
   hMenuDataEntry = LoadMenu (hInst, "MdiMenuDataEntry") ;
   hMenuRect  = LoadMenu (hInst, "MdiMenuRect") ;
   hMenuControls  = LoadMenu (hInst, "MdiMenuControls") ;

   hMenuInitWindow  = GetSubMenu (hMenuInit,   INIT_MENU_POS) ;
   hMenuDataEntryWindow = GetSubMenu (hMenuDataEntry, DATAENTRY_MENU_POS) ;
   hMenuRectWindow  = GetSubMenu (hMenuRect,   RECT_MENU_POS) ;
   hMenuControlsWindow  = GetSubMenu (hMenuControls,   CONTROLS_MENU_POS) ;

             // Load accelerator table

   hAccel = LoadAccelerators (hInst, "MdiAccel") ;

             // Create the frame window

   hwndFrame = CreateWindow (szFrameClass, "MDI Demonstration",
                             WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN,
                             CW_USEDEFAULT, CW_USEDEFAULT,
                             CW_USEDEFAULT, CW_USEDEFAULT,
                             NULL, hMenuInit, hInstance, NULL) ;

   hwndClient = GetWindow (hwndFrame, GW_CHILD) ;

   ShowWindow (hwndFrame, nCmdShow) ;
   UpdateWindow (hwndFrame) ;

             // Enter the modified message loop

   while (GetMessage (&msg, NULL, 0, 0))
        {
        if (!TranslateMDISysAccel (hwndClient, &msg) &&
            !TranslateAccelerator (hwndFrame, hAccel, &msg))
             {
             TranslateMessage (&msg) ;
             DispatchMessage (&msg) ;
             }
        }
   return msg.wParam ;
   }

long FAR PASCAL FrameWndProc (HWND hwnd, WORD message,
                              WORD wParam, LONG lParam)
   {
   static HWND        hwndClient ;
   CLIENTCREATESTRUCT clientcreate ;
   FARPROC            lpfnEnum ;
   HWND               hwndChild, hwndNext ;
   MDICREATESTRUCT    mdicreate ;

   switch (message)
      {
      case WM_CREATE:          // Create the client window

         clientcreate.hWindowMenu  = hMenuInitWindow ;
         clientcreate.idFirstChild = IDM_FIRSTCHILD ;

         hwndClient = CreateWindow ("MDICLIENT", NULL,
                        WS_CHILD | WS_CLIPCHILDREN | WS_VISIBLE,
                        0, 0, 0, 0, hwnd, 1, hInst,
                        (LPSTR) &clientcreate) ;
         return 0 ;

      case WM_COMMAND:
         switch (wParam)
           {
           case IDM_DATAENTRY :       // Create a DataEntry child window
                if(!(MDI1 = vwCreateView(gblInstance,
                                "MDI1",
                                hwndClient,
                                lpfnDataEntryWndProc,
                                NULL)))
                      return FALSE;

                vwSetViewCaption(MDI1, "Data Entry MDI Screen");
                vwSetViewIcon(MDI1, LoadIcon(NULL, IDI_ASTERISK));

                if((RetCode = vwShowMDIChildView(MDI1, hwndClient)) == -1)
                {
                      MessageBox(NULL, "Unable to display view", "System Error",
                                MB_SYSTEMMODAL | MB_ICONHAND | MB_OK);
                      return FALSE;
                }
              return 0 ;

           case IDM_RECT:        // Create a Rect child window

              if(!(MDI2 = vwCreateView(gblInstance,
                              "MDI2",
                              hwndClient,
                              lpfnRectWndProc,
                              NULL)))
                    return FALSE;
              vwSetViewCaption(MDI2, "Bitmap MDI Screen");
              vwSetViewIcon(MDI2, LoadIcon(NULL, IDI_HAND));

              if((RetCode = vwShowMDIChildView(MDI2, hwndClient)) == -1)
              {
                    MessageBox(NULL, "Unable to display view", "System Error",
                              MB_SYSTEMMODAL | MB_ICONHAND | MB_OK);
                    return FALSE;
              }

              return 0 ;

           case IDM_CONTROLS:        // Create a Controls child window

              if(!(MDI3 = vwCreateView(gblInstance,
                              "Controls",
                              hwndClient,
                              lpfnControlsWndProc,
                              NULL)))
                    return FALSE;
              vwSetViewCaption(MDI3, "Control Screen");
              vwSetViewIcon(MDI3, LoadIcon(NULL, IDI_QUESTION));

              if((RetCode = vwShowMDIChildView(MDI3, hwndClient)) == -1)
              {
                    MessageBox(NULL, "Unable to display view", "System Error",
                              MB_SYSTEMMODAL | MB_ICONHAND | MB_OK);
                    return FALSE;
              }
              return 0 ;

           case IDM_CLOSE:          // Close the active window

              hwndChild = LOWORD (SendMessage (hwndClient,
                                       WM_MDIGETACTIVE, 0, 0L)) ;

              if (SendMessage (hwndChild, WM_QUERYENDSESSION, 0, 0L))
                   SendMessage (hwndClient, WM_MDIDESTROY,
                                hwndChild, 0L) ;
              return 0 ;

           case IDM_EXIT:           // Exit the program

              SendMessage (hwnd, WM_CLOSE, 0, 0L) ;
              return 0 ;

                        // Messages for arranging windows
           case IDM_TILE:
              SendMessage (hwndClient, WM_MDITILE, 0, 0L) ;
              return 0 ;

           case IDM_CASCADE:
              SendMessage (hwndClient, WM_MDICASCADE, 0, 0L) ;
              return 0 ;

           case IDM_ARRANGE:
              SendMessage (hwndClient, WM_MDIICONARRANGE, 0, 0L) ;
              return 0 ;

           case IDM_CLOSEALL:       // Attempt to close all children

              lpfnEnum = MakeProcInstance (CloseEnumProc, hInst) ;
              EnumChildWindows (hwndClient, lpfnEnum, 0L) ;
              FreeProcInstance (lpfnEnum) ;
              return 0 ;

           default:            // Pass to active child

              hwndChild = LOWORD (SendMessage (hwndClient,
                                  WM_MDIGETACTIVE, 0, 0L)) ;

             if (IsWindow (hwndChild))
                  SendMessage (hwndChild, WM_COMMAND,
                               wParam, lParam) ;

             break ;        // and then to DefFrameProc
           }
         break ;

      case WM_QUERYENDSESSION:
      case WM_CLOSE:       // Attempt to close all children

         SendMessage (hwnd, WM_COMMAND, IDM_CLOSEALL, 0L) ;

         if (NULL != GetWindow (hwndClient, GW_CHILD))
              return 0 ;

         break ;   // ie, call DefFrameProc ;

      case WM_DESTROY :
         PostQuitMessage (0) ;
         return 0 ;
      }
        // Pass unprocessed msgs to DefFrameProc (not DefWindowProc)

   return DefFrameProc (hwnd, hwndClient, message, wParam, lParam) ;
   }

BOOL FAR PASCAL CloseEnumProc (HWND hwnd, LONG lParam)
{
     if(IsWindow(hwnd))
        if (GetWindow (hwnd, GW_OWNER))         // check for icon title
             return 1;
        else
            ;
     else
        return 1;
     SendMessage(GetParent(hwnd), WM_MDIRESTORE, hwnd, 0L) ;

     SendMessage(GetParent(hwnd), WM_MDIRESTORE, hwnd, 0L) ;
     if (!SendMessage (hwnd, WM_QUERYENDSESSION, 0, 0L))
          return 1 ;
     SendMessage (GetParent (hwnd), WM_MDIDESTROY, hwnd, 0L) ;
          return 1 ;
}

long FAR PASCAL DataEntryWndProc (HWND hwnd, WORD message,
                            WORD wParam, LONG lParam)
   {
   static HWND     hwndClient, hwndFrame ;
   HDC             hdc ;
   HMENU           hMenu ;
   PAINTSTRUCT     ps ;
   RECT            rect ;

   switch (message)
      {
      case WM_CREATE:
         hwndClient = GetParent (hwnd) ;
         hwndFrame  = GetParent (hwndClient) ;
         return 0 ;

      case WM_MDIACTIVATE:

                   // Set the DataEntry menu if gaining focus

         if (wParam == TRUE)
              SendMessage (hwndClient, WM_MDISETMENU, 0,
                           MAKELONG (hMenuDataEntry, hMenuDataEntryWindow)) ;

         else
         if (wParam == FALSE)
              SendMessage (hwndClient, WM_MDISETMENU, 0,
                           MAKELONG (hMenuInit, hMenuInitWindow)) ;

         DrawMenuBar (hwndFrame) ;
         break;

      case WM_QUERYENDSESSION:
      case WM_CLOSE:
         if (IDOK != MessageBox (hwnd,"OK to close window?","DataEntry",
                                 MB_ICONQUESTION | MB_OKCANCEL))
              return 0 ;

         break ;   // ie, call DefMDIChildProc

      case WM_DESTROY:
         return 0 ;
      }
         // Pass unprocessed message to DefMDIChildViewProc

   return DefMDIChildViewProc (hwnd, message, wParam, lParam) ;
   }

long FAR PASCAL RectWndProc (HWND hwnd, WORD message,
                           WORD wParam, LONG lParam)
   {
   static HWND hwndClient, hwndFrame ;
   HPEN        hBrush ;
   HDC         hdc ;
   PAINTSTRUCT ps ;
   short       xLeft, xRight, yTop, yBottom, nRed, nGreen, nBlue ;

   switch (message)
        {
      case WM_CREATE:
         hwndClient = GetParent (hwnd) ;
         hwndFrame  = GetParent (hwndClient) ;
         return 0 ;

      case WM_MDIACTIVATE:     // Set the appropriate menu
         if (wParam == TRUE)
              SendMessage (hwndClient, WM_MDISETMENU, 0,
                           MAKELONG (hMenuRect, hMenuRectWindow)) ;
         else
              SendMessage (hwndClient, WM_MDISETMENU, 0,
                           MAKELONG (hMenuInit, hMenuInitWindow)) ;

         DrawMenuBar (hwndFrame) ;
         break;

      case WM_QUERYENDSESSION:
      case WM_CLOSE:
         if (IDOK != MessageBox (hwnd,"OK to close window?","DataEntry",
                                 MB_ICONQUESTION | MB_OKCANCEL))
              return 0 ;

         break ;   // ie, call DefMDIChildProc

      case WM_DESTROY:
         return 0 ;
      }
         // Pass unprocessed message to DefMDIChildViewProc

   return DefMDIChildViewProc (hwnd, message, wParam, lParam) ;
   }

long FAR PASCAL ControlsWndProc (HWND hwnd, WORD message,
                           WORD wParam, LONG lParam)
   {
   static HWND hwndClient, hwndFrame ;
   HPEN        hBrush ;
   HDC         hdc ;
   PAINTSTRUCT ps ;
   short       xLeft, xRight, yTop, yBottom, nRed, nGreen, nBlue ;

   switch (message)
        {
      case WM_CREATE:
         hwndClient = GetParent (hwnd) ;
         hwndFrame  = GetParent (hwndClient) ;
         return 0 ;

      case WM_MDIACTIVATE:     // Set the appropriate menu
         if (wParam == TRUE)
              SendMessage (hwndClient, WM_MDISETMENU, 0,
                           MAKELONG (hMenuControls, hMenuControlsWindow)) ;
         else
              SendMessage (hwndClient, WM_MDISETMENU, 0,
                           MAKELONG (hMenuInit, hMenuInitWindow)) ;

         DrawMenuBar (hwndFrame) ;
         break;

      case WM_QUERYENDSESSION:
      case WM_CLOSE:
         if (IDOK != MessageBox (hwnd,"OK to close window?","Controls",
                                 MB_ICONQUESTION | MB_OKCANCEL))
              return 0 ;

         break ;   // ie, call DefMDIChildProc

      case WM_DESTROY:
         return 0 ;
      }
         // Pass unprocessed message to DefMDIChildViewProc

   return DefMDIChildViewProc (hwnd, message, wParam, lParam) ;
   }


